package com.ruoyi.system.service.impl;

import java.util.*;
import java.util.stream.Collectors;
import javax.annotation.PostConstruct;

import com.ruoyi.ext.api.domain.SysObjDictRet;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.ruoyi.common.core.constant.UserConstants;
import com.ruoyi.common.core.exception.ServiceException;
import com.ruoyi.common.core.utils.StringUtils;
import com.ruoyi.common.security.utils.DictUtils;
import com.ruoyi.system.api.domain.SysDictData;
import com.ruoyi.system.api.domain.SysDictType;
import com.ruoyi.system.mapper.SysDictDataMapper;
import com.ruoyi.system.mapper.SysDictTypeMapper;
import com.ruoyi.system.service.ISysDictTypeService;

/**
 * 字典 业务层处理
 * 
 * @author ruoyi
 */
@Service
public class SysDictTypeServiceImpl implements ISysDictTypeService
{
    @Autowired
    private SysDictTypeMapper dictTypeMapper;

    @Autowired
    private SysDictDataMapper dictDataMapper;

    /**
     * 项目启动时，初始化字典到缓存
     */
    @PostConstruct
    public void init()
    {
        loadingDictCache();
    }

    /**
     * 根据条件分页查询字典类型
     * 
     * @param dictType 字典类型信息
     * @return 字典类型集合信息
     */
    @Override
    public List<SysDictType> selectDictTypeList(SysDictType dictType)
    {
        return dictTypeMapper.selectDictTypeList(dictType);
    }

    /**
     * 根据所有字典类型
     * 
     * @return 字典类型集合信息
     */
    @Override
    public List<SysDictType> selectDictTypeAll()
    {
        return dictTypeMapper.selectDictTypeAll();
    }

    /**
     * 根据字典类型查询字典数据
     * 
     * @param dictType 字典类型
     * @return 字典数据集合信息
     */
    @Override
    public List<SysDictData> selectDictDataByType(String dictType)
    {
        List<SysDictData> dictDatas = DictUtils.getDictCache(dictType);
        if (StringUtils.isNotEmpty(dictDatas))
        {
            return dictDatas;
        }
        dictDatas = dictDataMapper.selectDictDataByType(dictType);
        if (StringUtils.isNotEmpty(dictDatas))
        {
            DictUtils.setDictCache(dictType, dictDatas);
            return dictDatas;
        }
        return null;
    }

    /**
     * 根据字典类型ID查询信息
     * 
     * @param dictId 字典类型ID
     * @return 字典类型
     */
    @Override
    public SysDictType selectDictTypeById(Long dictId)
    {
        return dictTypeMapper.selectDictTypeById(dictId);
    }

    /**
     * 根据字典类型查询信息
     * 
     * @param dictType 字典类型
     * @return 字典类型
     */
    @Override
    public SysDictType selectDictTypeByType(String dictType)
    {
        return dictTypeMapper.selectDictTypeByType(dictType);
    }

    /**
     * 批量删除字典类型信息
     * 
     * @param dictIds 需要删除的字典ID
     */
    @Override
    public void deleteDictTypeByIds(Long[] dictIds)
    {
        for (Long dictId : dictIds)
        {
            SysDictType dictType = selectDictTypeById(dictId);
            if (dictDataMapper.countDictDataByType(dictType.getDictType()) > 0)
            {
                throw new ServiceException(String.format("%1$s已分配,不能删除", dictType.getDictName()));
            }
            dictTypeMapper.deleteDictTypeById(dictId);
            DictUtils.removeDictCache(dictType.getDictType());
        }
    }

    /**
     * 加载字典缓存数据
     */
    @Override
    public void loadingDictCache()
    {
        SysDictData dictData = new SysDictData();
        dictData.setStatus("0");
        Map<String, List<SysDictData>> dictDataMap = dictDataMapper.selectDictDataList(dictData).stream().collect(Collectors.groupingBy(SysDictData::getDictType));
        for (Map.Entry<String, List<SysDictData>> entry : dictDataMap.entrySet())
        {
            DictUtils.setDictCache(entry.getKey(), entry.getValue().stream().sorted(Comparator.comparing(SysDictData::getDictSort)).collect(Collectors.toList()));
        }
    }

    /**
     * 清空字典缓存数据
     */
    @Override
    public void clearDictCache()
    {
        DictUtils.clearDictCache();
    }

    /**
     * 重置字典缓存数据
     */
    @Override
    public void resetDictCache()
    {
        clearDictCache();
        loadingDictCache();
    }

    /**
     * 新增保存字典类型信息
     * 
     * @param dict 字典类型信息
     * @return 结果
     */
    @Override
    public int insertDictType(SysDictType dict)
    {
        int row = dictTypeMapper.insertDictType(dict);
        if (row > 0)
        {
            DictUtils.setDictCache(dict.getDictType(), null);
        }
        return row;
    }

    /**
     * 修改保存字典类型信息
     * 
     * @param dict 字典类型信息
     * @return 结果
     */
    @Override
    @Transactional(rollbackFor = Exception.class)
    public int updateDictType(SysDictType dict)
    {
        SysDictType oldDict = dictTypeMapper.selectDictTypeById(dict.getDictId());
        dictDataMapper.updateDictDataType(oldDict.getDictType(), dict.getDictType());
        int row = dictTypeMapper.updateDictType(dict);
        if (row > 0)
        {
            List<SysDictData> dictDatas = dictDataMapper.selectDictDataByType(dict.getDictType());
            DictUtils.setDictCache(dict.getDictType(), dictDatas);
        }
        return row;
    }

    /**
     * 校验字典类型称是否唯一
     * 
     * @param dict 字典类型
     * @return 结果
     */
    @Override
    public String checkDictTypeUnique(SysDictType dict)
    {
        Long dictId = StringUtils.isNull(dict.getDictId()) ? -1L : dict.getDictId();
        SysDictType dictType = dictTypeMapper.checkDictTypeUnique(dict.getDictType());
        if (StringUtils.isNotNull(dictType) && dictType.getDictId().longValue() != dictId.longValue())
        {
            return UserConstants.NOT_UNIQUE;
        }
        return UserConstants.UNIQUE;
    }

    public SysObjDictRet objDictList(String dicttype, String outtype, String userid, String userunit, String para1, String para2, String para3, String para4, String para5)
    {
        List<Map<String,Object>> mapList =  dictTypeMapper.selectobjdict(dicttype,outtype,userid,userunit,para1,para2,para3,para4,para5);
        SysObjDictRet ObjDictRet= new SysObjDictRet();
        int count=0;
        ArrayList datas=(ArrayList) mapList;
        int fieldcount=7;

        String[] hfields=new String [fieldcount];
        hfields[0]="bm";hfields[1]="mc";hfields[2]="att1";hfields[3]="att2";hfields[4]="att3";hfields[5]="att4";hfields[6]="att5";
        count=datas.size();
        String[][] hdatas=new String[count][fieldcount];
        for (int i=0;i<count;i++)
        {
            for (int j=0;j<fieldcount;j++) {
                Object ob=((HashMap) ((ArrayList) datas).get(i)).get(hfields[j]);
                if (ob==null)
                    hdatas[i][j] ="";
                else
                    hdatas[i][j] =ob.toString();
            }
        }
        ObjDictRet.setCount(count);
        ObjDictRet.setData(hdatas);
        ObjDictRet.setFields(hfields);

        return ObjDictRet;
    }
    public SysObjDictRet tableList( String dicttype,String outtype,String userid,String userunit,String para1, String para2,  String para3,String para4,  String para5)
    {
        List<Map<String,Object>> mapList =  dictTypeMapper.selecttable(dicttype,outtype,userid,userunit,para1,para2,para3,para4,para5);
        SysObjDictRet ObjDictRet= new SysObjDictRet();
        ArrayList titleb=(ArrayList)mapList.get(0);
        ArrayList fields=(ArrayList) mapList.get(1);
        ArrayList datas=(ArrayList) mapList.get(2);
        int fieldcount=Integer.parseInt(((HashMap) ((ArrayList) titleb).get(0)).get("fieldcount").toString());
        ObjDictRet.setTitle(((HashMap) ((ArrayList) titleb).get(0)).get("title").toString());
        ObjDictRet.setFieldcount(fieldcount);
        String[] hfields=new String [fieldcount];
        String[] hfieldws=new String[fieldcount];
        String[] headers=new String [fieldcount];
        String fhs="";
        String[] fhsls=null;
        for (int i=0;i<fieldcount;i++)
        {
            fhs ="";
            Object ob=((HashMap) ((ArrayList) fields).get(0)).get("f"+Integer.toString(i+1));
            if (ob!=null)
                fhs =ob.toString();
            fhsls=fhs.split("[|]");
            if (fhs.length()>0 &&fhsls.length>=3)
            {
                hfields[i]=fhsls[0];
                headers[i]=fhsls[1];
                if (fhsls[2].equals("0"))
                    hfieldws[i]="-1";
                else {
                    hfieldws[i] = "200";
                    if (fhsls.length==4)
                        hfieldws[i] = fhsls[3];
                }
            }
        }
        int count=datas.size();
        String[][] hdatas=new String[count][fieldcount];
        for (int i=0;i<count;i++)
        {
            for (int j=0;j<fieldcount;j++) {
                Object ob=((HashMap) ((ArrayList) datas).get(i)).get(hfields[j]);
                if (ob==null)
                    hdatas[i][j] ="";
                else
                    hdatas[i][j] =ob.toString();
            }
        }
        ObjDictRet.setCount(count);
        ObjDictRet.setData(hdatas);
        ObjDictRet.setFields(hfields);
        ObjDictRet.setHeaders(headers);
        ObjDictRet.setFieldwidths(hfieldws);
        return ObjDictRet;
    }
}
